## qmidiarp 0.7.1+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(qmidiarp VERSION 0.7.1
        DESCRIPTION "MIDI arpeggiator, sequencer and LFO for ALSA and JACK"
        LANGUAGES C CXX)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED True)

set (APP_NAME "QMidiArp")
set (PACKAGE "qmidiarp")
set (PACKAGE_NAME "qmidiarp")
set (PACKAGE_VERSION "${PROJECT_VERSION}")
set (PACKAGE_BUGREPORT "emuse@users.sourceforge.net")
set (PACKAGE_STRING "${PACKAGE_NAME}-${PACKAGE_VERSION}")
set (PACKAGE_TARNAME "qmidiarp")
set (VERSION "${PROJECT_VERSION}")

if (CMAKE_BUILD_TYPE MATCHES "Debug")
    set(CONFIG_DEBUG 1)
else ()
    set(CONFIG_DEBUG 0)
endif ()

set (CONFIG_PREFIX "${CMAKE_INSTALL_PREFIX}")
set (CONFIG_LV2DIR "${CMAKE_INSTALL_PREFIX}/lib/lv2")

include (GNUInstallDirs)
set (CONFIG_BINDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_BINDIR}")
set (CONFIG_LIBDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
set (CONFIG_DATADIR "${CONFIG_PREFIX}/${CMAKE_INSTALL_DATADIR}")
set (CONFIG_MANDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_MANDIR}")

option (CONFIG_APPBUILD "Build QMidiArp Application (default=yes)" 1)
option (CONFIG_JACK_MIDI "Enable JACK MIDI support (default=yes)" 1)
option (CONFIG_ALSA_MIDI "Enable ALSA MIDI support (default=yes)" 1)

# Enable LV2 plugin build.
option (CONFIG_LV2 "Build LV2 plug-ins (default=yes)" 1)
option (CONFIG_LV2_UI "Build LV2 plug-in UIs with Qt (default=yes)" 1)
option (CONFIG_LV2_UI_RTK  "Build LV2 plug-in UIs with RobTk (default=yes)" 1)

# Enable NSM support.
option (CONFIG_NSM "Enable NSM support (default=yes)" 1)
set (APPBUILD ${CONFIG_APBUILD})

# Enable translations.
option (CONFIG_TRANSLATIONS "Build and install translations (default=no)" 1)
set (APPBUILD ${CONFIG_TRANSLATIONS})

# Fix for new CMAKE_REQUIRED_LIBRARIES policy.
if (POLICY CMP0075)
  cmake_policy (SET CMP0075 NEW)
endif ()

# Fix for CXX_VISIBILITY_PRESET policy.
if (POLICY CMP0063)
  cmake_policy (SET CMP0063 NEW)
  set (CMAKE_CXX_VISIBILITY_PRESET hidden)
  set (CMAKE_VISIBILITY_INLINES_HIDDEN 1)
endif ()

# Check for Qt
if (CONFIG_APPBUILD OR CONFIG_LV2_UI)
  find_package (QT NAMES Qt5 COMPONENTS Core REQUIRED)
  find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml)
  # Check for lrelease translations
  if (CONFIG_TRANSLATIONS)
    find_program (CONFIG_LRELEASE NAMES "lrelease" DOC "lrelease executable location")
    if (NOT CONFIG_LRELEASE)
        set(CONFIG_TRANSLATIONS  0)
        message("Translation generation disabled, lrelease not found")
    else()
        find_program (CONFIG_LUPDATE NAMES "lupdate" DOC "lupdate executable location")
        message("lrelease found: ${CONFIG_LRELEASE}")
        message("Will build translations")
    endif()
  endif()
endif ()

#find_package (Qt${QT_VERSION_MAJOR}LinguistTools)

include (CheckIncludeFileCXX)
include (CheckIncludeFiles)
include (CheckIncludeFile)
include (CheckFunctionExists)
include (CheckLibraryExists)

# Checks for header files.
if (UNIX AND NOT APPLE)
  check_include_files ("fcntl.h;unistd.h;signal.h" HAVE_SIGNAL_H)
endif ()

# Find package modules
find_package (PkgConfig REQUIRED)

if (NOT CONFIG_APPBUILD)
  set (CONFIG_JACK_MIDI 0)
  set (CONFIG_ALSA_MIDI 0)
  set (CONFIG_NSM 0)
endif ()

    
# Check for liblo
if (CONFIG_NSM)
  pkg_check_modules (LIBLO IMPORTED_TARGET liblo)
  if (LIBLO_FOUND)
    include_directories (${LIBLO_INCLUDE_DIRS})
    link_directories (${LIBLO_LIBRARY_DIRS})
    link_libraries (${LIBLO_LIBRARIES})
    set (NSM 1)
  else ()
    message (WARNING "*** LIBLO library not found. Deactivating NSM support")
    set (CONFIG_LIBLO 0)
  endif ()
endif ()

# Check for JACK libraries.
if (CONFIG_APPBUILD)
  pkg_check_modules (JACK IMPORTED_TARGET jack>=0.100.0)
  if (JACK_FOUND)
    include_directories (${JACK_INCLUDE_DIRS})
    link_directories (${JACK_LIBRARY_DIRS})
  # link_libraries (${JACK_LIBRARIES})
    set (CMAKE_REQUIRED_LIBRARIES "${JACK_LIBRARIES};${CMAKE_REQUIRED_LIBRARIES}")
    # Check for JACK MIDI headers availability.
    if (CONFIG_JACK_MIDI)
      check_include_files (jack/midiport.h HAVE_JACK_MIDIPORT_H)
      if (NOT HAVE_JACK_MIDIPORT_H)
        set (HAVE_JACK 0)
      else ()
        set (HAVE_JACK 1)
        set (APPBUILD 1)
      endif ()
    endif ()
    # Check for ALSA libraries.

    if (CONFIG_ALSA_MIDI)
      pkg_check_modules (ALSA IMPORTED_TARGET alsa)
      set (CONFIG_ALSA_MIDI ${ALSA_FOUND})
      if (CONFIG_ALSA_MIDI)
        include_directories (${ALSA_INCLUDE_DIRS})
        link_directories (${ALSA_LIBRARY_DIRS})
        link_libraries (${ALSA_LIBRARIES})
        set (HAVE_ALSA 1)
        set (APPBUILD 1)
        message ("Will build QMidiArp application")
      else ()
        set (HAVE_ALSA 0)
        if (NOT HAVE_JACK)
          set (APPBUILD 0)
            message (WARNING "*** Cannot build application without backend driver.")
        endif ()
        message (WARNING "*** ALSA library not found.")
      endif ()
    endif ()
  else ()
    message (WARNING "*** JACK library not found.")
    set (CONFIG_JACK 0)
  endif ()
endif ()

# Check for LV2 support.
if (CONFIG_LV2)
  pkg_check_modules (LV2 lv2)
  if (LV2_FOUND)
    include_directories (${LV2_INCLUDE_DIRS})
    link_directories (${LV2_LIBRARY_DIRS})
    link_libraries (${LV2_LIBRARIES})
    # Check for LV2 Atom support.
    check_include_file (lv2/lv2plug.in/ns/ext/atom/atom.h HAVE_LV2_ATOM_H)
    if (NOT HAVE_LV2_ATOM_H)
      set (CONFIG_LV2_ATOM 0)
    else ()
      set (CONFIG_LV2_ATOM 1)
      set (BUILD_LV2 1)
      message ("Will build LV2 plugins")
    endif ()
    set (CONFIG_LV2_ATOM_FORGE_OBJECT ${CONFIG_LV2_ATOM})
    set (CONFIG_LV2_ATOM_FORGE_KEY ${CONFIG_LV2_ATOM})
    # Check for LV2 UI support.
    check_include_file (lv2/lv2plug.in/ns/extensions/ui/ui.h HAVE_LV2_UI_H)
    if (NOT HAVE_LV2_UI_H)
      set (CONFIG_LV2_UI 0)
    else ()
      set (CONFIG_LV2_UI 1)
    endif ()
  else ()
    message (WARNING "*** LV2 headers not found.")
    set (CONFIG_LV2 0)
  endif ()
endif ()

if (CONFIG_LV2_UI_RTK)
  if(NOT EXISTS "${CMAKE_SOURCE_DIR}/robtk/ui_gl.c")
    set(CONFIG_LV2_UI_RTK, false)
    message(WARNING "*** robtk not found in source tree. Did you forget git submodule update --init ?")
    message("Will not build RTK LV2 UIs.")
  endif()
  pkg_check_modules (LV2 lv2)
  if (LV2_FOUND)
    include_directories (${LV2_INCLUDE_DIRS})
    link_directories (${LV2_LIBRARY_DIRS})
    link_libraries (${LV2_LIBRARIES})
    # Check for LV2 Atom support.
    check_include_file (lv2/lv2plug.in/ns/ext/atom/atom.h HAVE_LV2_ATOM_H)
    if (NOT HAVE_LV2_ATOM_H)
      set (CONFIG_LV2_ATOM 0)
    else ()
      set (CONFIG_LV2_ATOM 1)
      set (BUILD_LV2_UI_RTK 1)
    endif ()
    set (CONFIG_LV2_ATOM_FORGE_OBJECT ${CONFIG_LV2_ATOM})
    set (CONFIG_LV2_ATOM_FORGE_KEY ${CONFIG_LV2_ATOM})
    # Check for LV2 UI support.
    check_include_file (lv2/lv2plug.in/ns/extensions/ui/ui.h HAVE_LV2_UI_H)
    if (NOT HAVE_LV2_UI_H)
      set (CONFIG_LV2_UI_RTK 0)
    else ()
      set (CONFIG_LV2_UI_RTK 1)
    endif ()
  else ()
    message (WARNING "*** LV2 headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()

  pkg_check_modules (PANGO pango)
  if (PANGO_FOUND)
    include_directories (${PANGO_INCLUDE_DIRS})
    link_directories (${PANGO_LIBRARY_DIRS})
    link_libraries (${PANGO_LIBRARIES})
  else ()
    message (WARNING "*** PANGO headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()
  
  pkg_check_modules (CAIRO cairo)
  if (PANGO_FOUND)
    include_directories (${CAIRO_INCLUDE_DIRS})
    link_directories (${CAIRO_LIBRARY_DIRS})
    link_libraries (${CAIRO_LIBRARIES})
  else ()
    message (WARNING "*** CAIRO headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()
   
  pkg_check_modules (PANGOCAIRO pangocairo)
  if (PANGOCAIRO_FOUND)
    include_directories (${PANGOCAIRO_INCLUDE_DIRS})
    link_directories (${PANGOCAIRO_LIBRARY_DIRS})
    link_libraries (${PANGOCAIRO_LIBRARIES})
  else ()
    message (WARNING "*** PANGOCAIRO headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()
  
  pkg_check_modules (GLU glu)
  if (GLU_FOUND)
    include_directories (${GLU_INCLUDE_DIRS})
    link_directories (${GLU_LIBRARY_DIRS})
    link_libraries (${GLU_LIBRARIES})
  else ()
    message (WARNING "*** GLU headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()
  
  pkg_check_modules (GL gl)
  if (GL_FOUND)
    include_directories (${GL_INCLUDE_DIRS})
    link_directories (${GL_LIBRARY_DIRS})
    link_libraries (${GL_LIBRARIES})
  else ()
    message (WARNING "*** GL headers not found.")
    set (CONFIG_LV2_UI_RTK 0)
  endif ()
endif ()

if (BUILD_LV2 AND CONFIG_LV2_UI AND QT_FOUND)
    message ("Will build LV2 UIs\n")
    set(BUILD_LV2_UI 1)
endif ()

if (BUILD_LV2 AND CONFIG_LV2_UI_RTK)
    message ("Will build RobTk LV2 UIs\n")
    set(BUILD_LV2_UI_RTK 1)
endif ()

add_subdirectory(src)
add_subdirectory(qmidiarp_arp.lv2)
add_subdirectory(qmidiarp_lfo.lv2)
add_subdirectory(qmidiarp_seq.lv2)

if (EXISTS ${CMAKE_SOURCE_DIR}/configure)
    set(ADD_AUTOCONF_FILES  --add-file=${CMAKE_SOURCE_DIR}/configure
                            --add-file=${CMAKE_SOURCE_DIR}/aclocal.m4
                            --add-file=${CMAKE_SOURCE_DIR}/compile
                            --add-file=${CMAKE_SOURCE_DIR}/config.guess
                            --add-file=${CMAKE_SOURCE_DIR}/config.sub
                            --add-file=${CMAKE_SOURCE_DIR}/depcomp
                            --add-file=${CMAKE_SOURCE_DIR}/install-sh
                            --add-file=${CMAKE_SOURCE_DIR}/ltmain.sh
                            --add-file=${CMAKE_SOURCE_DIR}/missing
                            --add-file=${CMAKE_SOURCE_DIR}/Makefile.in
                            --prefix=${PACKAGE_STRING}/m4/
                            --add-file=${CMAKE_SOURCE_DIR}/m4/libtool.m4
                            --add-file=${CMAKE_SOURCE_DIR}/m4/ltoptions.m4
                            --add-file=${CMAKE_SOURCE_DIR}/m4/ltsugar.m4
                            --add-file=${CMAKE_SOURCE_DIR}/m4/ltversion.m4
                            --add-file=${CMAKE_SOURCE_DIR}/m4/lt~obsolete.m4
                            --prefix=${PACKAGE_STRING}/man/
                            --add-file=${CMAKE_SOURCE_DIR}/man/Makefile.in
                            --prefix=${PACKAGE_STRING}/man/de/
                            --add-file=${CMAKE_SOURCE_DIR}/man//de/Makefile.in
                            --prefix=${PACKAGE_STRING}/man/fr/
                            --add-file=${CMAKE_SOURCE_DIR}/man//fr/Makefile.in
                            --prefix=${PACKAGE_STRING}/examples/
                            --add-file=${CMAKE_SOURCE_DIR}/examples/Makefile.in
                            --prefix=${PACKAGE_STRING}/src/
                            --add-file=${CMAKE_SOURCE_DIR}/src/config.h.in
                            --add-file=${CMAKE_SOURCE_DIR}/src/Makefile.in
                            --prefix=${PACKAGE_STRING}/src/pixmaps/
                            --add-file=${CMAKE_SOURCE_DIR}/src/pixmaps/Makefile.in
                            --prefix=${PACKAGE_STRING}/)

else ()
    set(ADD_AUTOCONF_FILES )
    message("Warning: No configure file found, will be missing when creating a dist archive")
endif ()

set(DIST_TARCOMMAND git --git-dir=${CMAKE_SOURCE_DIR}/.git archive 
                        --format=tar 
                        --prefix=${PACKAGE_STRING}/ ${ADD_AUTOCONF_FILES}
                        ${PACKAGE_STRING}^{tree} -o ${PACKAGE_STRING}.tar &&
                        git --git-dir=${CMAKE_SOURCE_DIR}/robtk/.git archive 
                        --format=tar 
                        --prefix=${PACKAGE_STRING}/robtk/ HEAD -o robtk.tar &&
                        tar --concatenate --file=${PACKAGE_STRING}.tar robtk.tar && 
                        rm -f robtk.tar)

add_custom_target(dist-bz2 COMMAND ${DIST_TARCOMMAND} && bzip2 -f ${PACKAGE_STRING}.tar )

=== qmidiarp_arp.lv2/CMakeLists.txt ===
install (FILES qmidiarp_arp.ttl DESTINATION ${CONFIG_LV2DIR}/qmidiarp_arp.lv2/)
install (FILES qmidiarp_arp_ui.ttl DESTINATION ${CONFIG_LV2DIR}/qmidiarp_arp.lv2/)
install (FILES manifest.ttl DESTINATION ${CONFIG_LV2DIR}/qmidiarp_arp.lv2/)

=== qmidiarp_lfo.lv2/CMakeLists.txt ===
install (FILES qmidiarp_lfo.ttl DESTINATION ${CONFIG_LV2DIR}/qmidiarp_lfo.lv2/)
install (FILES qmidiarp_lfo_ui.ttl DESTINATION ${CONFIG_LV2DIR}/qmidiarp_lfo.lv2/)
install (FILES manifest.ttl DESTINATION ${CONFIG_LV2DIR}/qmidiarp_lfo.lv2/)

=== qmidiarp_seq.lv2/CMakeLists.txt ===
install (FILES qmidiarp_seq.ttl DESTINATION ${CONFIG_LV2DIR}/qmidiarp_seq.lv2/)
install (FILES qmidiarp_seq_ui.ttl DESTINATION ${CONFIG_LV2DIR}/qmidiarp_seq.lv2/)
install (FILES manifest.ttl DESTINATION ${CONFIG_LV2DIR}/qmidiarp_seq.lv2/)

=== src/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)


if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
    file(REMOVE ${CMAKE_CURRENT_SOURCE_DIR}/config.h)
endif()

configure_file (cmake_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

if (APPBUILD)
    set (HEADERS
        cursor.h
        engine.h
        arpscreen.h
        lfoscreen.h
        seqscreen.h
        arpwidget.h
        lfowidget.h 
        seqwidget.h 
        groovewidget.h 
        mainwindow.h 
        globstore.h 
        indicator.h 
        modulewidget.h 
        logwidget.h 
        main.h 
        midiworker.h 
        midiarp.h 
        midilfo.h 
        midiseq.h 
        midicctable.h 
        midicontrol.h 
        midievent.h 
        nsm.h 
        driverbase.h 
        parstore.h 
        prefswidget.h 
        prefs.h 
        jackdriver.h 
        screen.h 
        seqdriver.h 
        slider.h 
        storagebutton.h
        )
    
    set( SOURCES
        cursor.cpp
        engine.cpp
        arpscreen.cpp
        lfoscreen.cpp
        seqscreen.cpp
        arpwidget.cpp
        lfowidget.cpp
        seqwidget.cpp
        groovewidget.cpp
        mainwindow.cpp
        globstore.cpp
        indicator.cpp
        modulewidget.cpp
        logwidget.cpp
        main.cpp
        midiworker.cpp
        midiarp.cpp
        midilfo.cpp
        midiseq.cpp
        midicctable.cpp
        midicontrol.cpp
        parstore.cpp
        prefswidget.cpp
        prefs.cpp
        jackdriver.cpp
        screen.cpp
        seqdriver.cpp
        slider.cpp
        storagebutton.cpp
    )
    set( DTRANSLATIONSDIR "")
    
    if (CONFIG_TRANSLATIONS)
        add_subdirectory(translations)
        set( DTRANSLATIONSDIR -DTRANSLATIONSDIR="${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/${PACKAGE}/translations/" )
    endif()
    
    add_executable (${PROJECT_NAME}
      ${HEADERS}
      ${SOURCES}
    )

    set_target_properties (${PROJECT_NAME} PROPERTIES CXX_STANDARD 11)
    target_compile_options(${PROJECT_NAME} PRIVATE -DAPPBUILD ${DTRANSLATIONSDIR})

    if (CONFIG_JACK_MIDI)
      target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::JACK)
    endif ()
    
    if (CONFIG_ALSA_MIDI)
      target_link_libraries (${PROJECT_NAME} PRIVATE PkgConfig::ALSA)
    endif ()
    
    target_link_libraries (${PROJECT_NAME} PUBLIC   Qt${QT_VERSION_MAJOR}::Core 
                                                    Qt${QT_VERSION_MAJOR}::Gui
                                                    Qt${QT_VERSION_MAJOR}::Widgets
                                                    )
    
    if (UNIX AND NOT APPLE AND NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
        COMMAND strip ${PROJECT_NAME})
    endif ()

    install (TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

endif ()
#LV2 DSPs

if (BUILD_LV2)
    set(LV2_ARP_HEADERS
        lv2_common.h
        main.h
        midiworker.h
        midiarp.h
        midiarp_lv2.h
    )
    
    set(LV2_ARP_SOURCES
        midiworker.cpp
        midiarp.cpp
        midiarp_lv2.cpp
    )
    
    set(LV2_LFO_HEADERS
        lv2_common.h
        main.h
        midiworker.h
        midilfo.h
        midilfo_lv2.h
    )
    
    set(LV2_LFO_SOURCES
        midiworker.cpp
        midilfo.cpp
        midilfo_lv2.cpp
    )
    
    set(LV2_SEQ_HEADERS
        lv2_common.h
        main.h
        midiworker.h
        midiseq.h
        midiseq_lv2.h
    )
    
    set(LV2_SEQ_SOURCES
        midiworker.cpp
        midiseq.cpp
        midiseq_lv2.cpp
    )
    
    add_library (${PROJECT_NAME}_arp MODULE
      ${LV2_ARP_HEADERS}
      ${LV2_ARP_SOURCES}
    )
    
    add_library (${PROJECT_NAME}_lfo MODULE
      ${LV2_LFO_HEADERS}
      ${LV2_LFO_SOURCES}
    )
    
    add_library (${PROJECT_NAME}_seq MODULE
      ${LV2_SEQ_HEADERS}
      ${LV2_SEQ_SOURCES}
    )

    set_target_properties (${PROJECT_NAME}_arp PROPERTIES CXX_STANDARD 11 PREFIX "")
    set_target_properties (${PROJECT_NAME}_lfo PROPERTIES CXX_STANDARD 11 PREFIX "")
    set_target_properties (${PROJECT_NAME}_seq PROPERTIES CXX_STANDARD 11 PREFIX "")

    if (UNIX AND NOT APPLE AND NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME}_arp  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_arp.so)
      add_custom_command(TARGET ${PROJECT_NAME}_lfo  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_lfo.so)
      add_custom_command(TARGET ${PROJECT_NAME}_seq  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_seq.so)
    endif ()

    if (UNIX AND NOT APPLE)
      if (CONFIG_PREFIX MATCHES $ENV{HOME})
        set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
      endif ()
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_arp.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2)
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_lfo.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_lfo.lv2)
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_seq.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_seq.lv2)
    endif ()
endif ()

# LV2 UIs
if (BUILD_LV2_UI)
    
    set(LV2UI_ARP_HEADERS
        cursor.h
        lv2_common.h
        main.h
        modulewidget.h
        arpwidget.h
        arpscreen.h
        screen.h
        slider.h
        arpwidget_lv2.h
    )
    
    set(LV2UI_ARP_SOURCES
        cursor.cpp
        modulewidget.cpp
        arpwidget.cpp
        arpscreen.cpp
        screen.cpp
        slider.cpp
        arpwidget_lv2.cpp
    )
    
    set(LV2UI_LFO_HEADERS
        cursor.h
        lv2_common.h
        main.h
        modulewidget.h
        lfowidget.h
        lfoscreen.h
        screen.h
        slider.h
        lfowidget_lv2.h
    )
    
    set(LV2UI_LFO_SOURCES
        cursor.cpp
        modulewidget.cpp
        lfowidget.cpp
        lfoscreen.cpp
        screen.cpp
        slider.cpp
        lfowidget_lv2.cpp
    )
    
    set(LV2UI_SEQ_HEADERS
        cursor.h
        lv2_common.h
        main.h
        modulewidget.h
        seqwidget.h
        seqscreen.h
        screen.h
        slider.h
        seqwidget_lv2.h
    )
    
    set(LV2UI_SEQ_SOURCES
        cursor.cpp
        modulewidget.cpp
        seqwidget.cpp
        seqscreen.cpp
        screen.cpp
        slider.cpp
        seqwidget_lv2.cpp
    )
    
    add_library (${PROJECT_NAME}_arp_ui MODULE
      ${LV2UI_ARP_HEADERS}
      ${LV2UI_ARP_SOURCES}
    )
    
    add_library (${PROJECT_NAME}_lfo_ui MODULE
      ${LV2UI_LFO_HEADERS}
      ${LV2UI_LFO_SOURCES}
    )
    
    add_library (${PROJECT_NAME}_seq_ui MODULE
      ${LV2UI_SEQ_HEADERS}
      ${LV2UI_SEQ_SOURCES}
    )

    set_target_properties (${PROJECT_NAME}_arp_ui PROPERTIES CXX_STANDARD 11 PREFIX "")
    set_target_properties (${PROJECT_NAME}_lfo_ui PROPERTIES CXX_STANDARD 11 PREFIX "")
    set_target_properties (${PROJECT_NAME}_seq_ui PROPERTIES CXX_STANDARD 11 PREFIX "")
    
    target_link_libraries (${PROJECT_NAME}_arp_ui PUBLIC   Qt${QT_VERSION_MAJOR}::Core 
                                                    Qt${QT_VERSION_MAJOR}::Gui
                                                    Qt${QT_VERSION_MAJOR}::Widgets
                                                    )
    
    target_link_libraries (${PROJECT_NAME}_lfo_ui PUBLIC   Qt${QT_VERSION_MAJOR}::Core 
                                                    Qt${QT_VERSION_MAJOR}::Gui
                                                    Qt${QT_VERSION_MAJOR}::Widgets
                                                    )
    
    target_link_libraries (${PROJECT_NAME}_seq_ui PUBLIC   Qt${QT_VERSION_MAJOR}::Core 
                                                    Qt${QT_VERSION_MAJOR}::Gui
                                                    Qt${QT_VERSION_MAJOR}::Widgets
                                                    )
    if (UNIX AND NOT APPLE AND NOT CONFIG_DEBUG)
      add_custom_command(TARGET ${PROJECT_NAME}_arp_ui  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_arp_ui.so)
      add_custom_command(TARGET ${PROJECT_NAME}_lfo_ui  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_lfo_ui.so)
      add_custom_command(TARGET ${PROJECT_NAME}_seq_ui  POST_BUILD
        COMMAND strip ${PROJECT_NAME}_seq_ui.so)
    endif ()

    if (UNIX AND NOT APPLE)
      if (CONFIG_PREFIX MATCHES $ENV{HOME})
        set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
      endif ()
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_arp_ui.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2)
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_lfo_ui.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_lfo.lv2)
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_seq_ui.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_seq.lv2)
    endif ()
    
endif()

# LV2 RobTk UIs
if (BUILD_LV2_UI_RTK)
    
    set(LV2UI_RTK_ARP_SOURCES
        ../robtk/pugl/pugl_x11.c
        ../robtk/ui_gl.c 
    )
  
    add_library (${PROJECT_NAME}_arp_ui_gl MODULE
      ${LV2UI_RTK_ARP_HEADERS}
      ${LV2UI_RTK_ARP_SOURCES}
    )

    set_target_properties (${PROJECT_NAME}_arp_ui_gl PROPERTIES C_STANDARD 11 PREFIX "")
    target_compile_options(${PROJECT_NAME}_arp_ui_gl PRIVATE   -g -Wall 
                                    -Wno-unused-function -fvisibility=hidden -DHAVE_LV2_1_8
                                    -DHAVE_IDLE_IFACE -I.
                                    -DUSE_GUI_THREAD -pthread -DUINQHACK="168162529512469" 
                                    -DPLUGIN_SOURCE="arpwidget_lv2_rtk.c"
                                    )
    
    target_link_libraries (${PROJECT_NAME}_arp_ui_gl PUBLIC -lX11)

    set(LV2UI_RTK_LFO_SOURCES
        ../robtk/pugl/pugl_x11.c
        ../robtk/ui_gl.c 
    )
  
    add_library (${PROJECT_NAME}_lfo_ui_gl MODULE
      ${LV2UI_RTK_LFO_HEADERS}
      ${LV2UI_RTK_LFO_SOURCES}
    )

    set_target_properties (${PROJECT_NAME}_lfo_ui_gl PROPERTIES C_STANDARD 11 PREFIX "")
    target_compile_options(${PROJECT_NAME}_lfo_ui_gl PRIVATE   -g -Wall 
                                    -Wno-unused-function -fvisibility=hidden -DHAVE_LV2_1_8
                                    -DUSE_GUI_THREAD -pthread -DUINQHACK="168162529512469" 
                                    -DHAVE_IDLE_IFACE -I.
                                    -DPLUGIN_SOURCE="lfowidget_lv2_rtk.c"
                                    )
    
    target_link_libraries (${PROJECT_NAME}_lfo_ui_gl PUBLIC -lX11)

    set(LV2UI_RTK_SEQ_SOURCES
        ../robtk/pugl/pugl_x11.c
        ../robtk/ui_gl.c 
    )
  
    add_library (${PROJECT_NAME}_seq_ui_gl MODULE
      ${LV2UI_RTK_SEQ_HEADERS}
      ${LV2UI_RTK_SEQ_SOURCES}
    )

    set_target_properties (${PROJECT_NAME}_seq_ui_gl PROPERTIES C_STANDARD 11 PREFIX "")
    target_compile_options(${PROJECT_NAME}_seq_ui_gl PRIVATE   -g -Wall 
                                    -Wno-unused-function -fvisibility=hidden -DHAVE_LV2_1_8
                                    -DUSE_GUI_THREAD -pthread -DUINQHACK="168162529512469" 
                                    -DHAVE_IDLE_IFACE -I.
                                    -DPLUGIN_SOURCE="seqwidget_lv2_rtk.c"
                                    )
    
    target_link_libraries (${PROJECT_NAME}_seq_ui_gl PUBLIC -lX11)

    if (UNIX AND NOT APPLE)
      if (CONFIG_PREFIX MATCHES $ENV{HOME})
        set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
      endif ()
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_arp_ui_gl.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2)
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_lfo_ui_gl.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_lfo.lv2)
      install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_seq_ui_gl.so
         DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_seq.lv2)
    endif ()

endif()

=== debian/changelog ===
qmidiarp (0.7.1+ds-1) unstable; urgency=medium

  * New upstream version 0.7.1+ds
  * Drop cross patch, applied by upstream

 -- Dennis Braun <snd@debian.org>  Fri, 13 Sep 2024 20:54:49 +0200

qmidiarp (0.7.0+ds-3) unstable; urgency=medium

  * Fix cross building. Thanks Helmut! (Closes: #1059750)
  * Apply wrap-and-sort -ast

 -- Dennis Braun <snd@debian.org>  Wed, 24 Jul 2024 09:55:37 +0200

qmidiarp (0.7.0+ds-2) unstable; urgency=medium

  * Build with robtk 0.8.5
  * Bump Standards-Version to 4.7.0
  * Use scour instead of dh-squence-scour
  * Use the default ci config from salsa

 -- Dennis Braun <snd@debian.org>  Tue, 23 Jul 2024 14:37:40 +0200

=== debian/control ===
Source: qmidiarp
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>,
 Dennis Braun <snd@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libasound2-dev [linux-any],
 libjack-dev | libjack-jackd2-dev,
 liblo-dev,
 libx11-dev,
 lv2-dev,
 qtbase5-dev,
 qttools5-dev-tools,
 robtk,
 scour,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://qmidiarp.sourceforge.io
Vcs-Git: https://salsa.debian.org/multimedia-team/qmidiarp.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/qmidiarp

Package: qmidiarp
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 jackd,
Description: MIDI arpeggiator for ALSA
 QMidiArp is an advanced MIDI arpeggiator, programmable step sequencer
 and LFO for the ALSA sequencer. It can hold any number of arpeggiator,
 sequencer, or LFO modules running in parallel.
 .
 Arpeggiator modules produce sequences depending on the notes sent
 to their input port, which is typically connected to a keyboard or
 another sequencer.
 .
 Step sequencer modules allow one to create simple linear, monophonic
 and globally transposable sequences similar to the first analog
 sequencers.
 .
 MIDI LFO modules independently produce MIDI controller data of
 adjustable waveform, time resolution, amplitude and duration.
 .
 For each module, an input note filter is available, and the output
 port and channel can be set independently. Since the modules use a
 common sequencer queue, they are automatically in sync with each other.
 QMidiArp works with an internal tick resolution of 192 ticks per beat.
 The queue can be synchronized to an incoming MIDI realtime clock or as
 a JACK transport client. Most of the relevant control elements are
 accessible via MIDI controller through a MIDI-learn infrastructure.
 QMidiArp also has a log tool displaying the history of incoming MIDI
 events in colors depending on their type. QMidiArp is based on the Qt
 toolkit.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export QT_SELECT=qt5


%:
	dh $@

execute_before_dh_auto_configure:
	cp -fr /usr/share/robtk .

override_dh_auto_configure:
	dh_auto_configure -- --with-pic

override_dh_auto_install:
	dh_auto_install --destdir=$(CURDIR)/debian/tmp

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/watch ===
version=4
opts=repacksuffix=+ds,dversionmangle=auto \
 https://sf.net/@PACKAGE@/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@

## qmidiarp 0.7.2%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.10)
-project(qmidiarp VERSION 0.7.1
+project(qmidiarp VERSION 0.7.2
         DESCRIPTION "MIDI arpeggiator, sequencer and LFO for ALSA and JACK"
         LANGUAGES C CXX)
 
@@ -15,24 +15,18 @@
 set (PACKAGE_TARNAME "qmidiarp")
 set (VERSION "${PROJECT_VERSION}")
 
+set(STRIP_DEBUG_SYMBOLS ON CACHE BOOL "Strip debug symbols (default=yes)")
 if (CMAKE_BUILD_TYPE MATCHES "Debug")
-    set(CONFIG_DEBUG 1)
-else ()
-    set(CONFIG_DEBUG 0)
-endif ()
-
-set (CONFIG_PREFIX "${CMAKE_INSTALL_PREFIX}")
-set (CONFIG_LV2DIR "${CMAKE_INSTALL_PREFIX}/lib/lv2")
+  set(STRIP_DEBUG_SYMBOLS OFF)
+endif ()
 
 include (GNUInstallDirs)
-set (CONFIG_BINDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_BINDIR}")
-set (CONFIG_LIBDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
-set (CONFIG_DATADIR "${CONFIG_PREFIX}/${CMAKE_INSTALL_DATADIR}")
-set (CONFIG_MANDIR  "${CONFIG_PREFIX}/${CMAKE_INSTALL_MANDIR}")
 
 option (CONFIG_APPBUILD "Build QMidiArp Application (default=yes)" 1)
+option (CONFIG_FORCE_QT5 "Force Qt5 instead of Qt6 (default=no)" 0)
 option (CONFIG_JACK_MIDI "Enable JACK MIDI support (default=yes)" 1)
 option (CONFIG_ALSA_MIDI "Enable ALSA MIDI support (default=yes)" 1)
+option (CONFIG_EXAMPLES "Install examples (default=no)" 0)
 
 # Enable LV2 plugin build.
 option (CONFIG_LV2 "Build LV2 plug-ins (default=yes)" 1)
@@ -41,11 +35,10 @@
 
 # Enable NSM support.
 option (CONFIG_NSM "Enable NSM support (default=yes)" 1)
-set (APPBUILD ${CONFIG_APBUILD})
+set (APPBUILD ${CONFIG_APPBUILD})
 
 # Enable translations.
-option (CONFIG_TRANSLATIONS "Build and install translations (default=no)" 1)
-set (APPBUILD ${CONFIG_TRANSLATIONS})
+option (CONFIG_TRANSLATIONS "Build and install translations (default=no)" 0)
 
 # Fix for new CMAKE_REQUIRED_LIBRARIES policy.
 if (POLICY CMP0075)
@@ -60,24 +53,20 @@
 endif ()
 
 # Check for Qt
-if (CONFIG_APPBUILD OR CONFIG_LV2_UI)
-  find_package (QT NAMES Qt5 COMPONENTS Core REQUIRED)
+if (CONFIG_APPBUILD OR CONFIG_LV2_UI)  
+  if (NOT CONFIG_FORCE_QT5)
+    find_package (QT NAMES Qt6 COMPONENTS Core OPTIONAL)
+  endif()
+  if (NOT QT_FOUND OR CONFIG_FORCE_QT5)
+    find_package (QT NAMES Qt5 COMPONENTS Core REQUIRED)
+  endif()
   find_package (Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Core Gui Widgets Xml)
+  message("Will build GUIs using Qt ${QT_VERSION}")
   # Check for lrelease translations
   if (CONFIG_TRANSLATIONS)
-    find_program (CONFIG_LRELEASE NAMES "lrelease" DOC "lrelease executable location")
-    if (NOT CONFIG_LRELEASE)
-        set(CONFIG_TRANSLATIONS  0)
-        message("Translation generation disabled, lrelease not found")
-    else()
-        find_program (CONFIG_LUPDATE NAMES "lupdate" DOC "lupdate executable location")
-        message("lrelease found: ${CONFIG_LRELEASE}")
-        message("Will build translations")
-    endif()
+    find_package (Qt${QT_VERSION_MAJOR}LinguistTools CONFIG REQUIRED)
   endif()
 endif ()
-
-#find_package (Qt${QT_VERSION_MAJOR}LinguistTools)
 
 include (CheckIncludeFileCXX)
 include (CheckIncludeFiles)
@@ -163,6 +152,15 @@
 if (CONFIG_LV2)
   pkg_check_modules (LV2 lv2)
   if (LV2_FOUND)
+    if (CMAKE_INSTALL_PREFIX MATCHES $ENV{HOME})
+      set (CONFIG_LV2DIR "${CMAKE_INSTALL_PREFIX}/.lv2" CACHE STRING "LV2 Path Configuration")
+    else ()
+      pkg_get_variable (LV2_SYSTEM_LV2DIR lv2 lv2dir)
+      set (CONFIG_LV2DIR "${CMAKE_INSTALL_FULL_LIBDIR}/lv2" CACHE STRING "LV2 Path Configuration")
+      if (NOT LV2_SYSTEM_LV2DIR STREQUAL CONFIG_LV2DIR)
+        message (WARNING "*** System LV2 Path is ${LV2_SYSTEM_LV2DIR}, mismatch with \${CONFIG_LV2DIR}=\"${CONFIG_LV2DIR}\"!")
+      endif ()
+    endif ()
     include_directories (${LV2_INCLUDE_DIRS})
     link_directories (${LV2_LIBRARY_DIRS})
     link_libraries (${LV2_LIBRARIES})
@@ -285,9 +283,15 @@
 endif ()
 
 add_subdirectory(src)
-add_subdirectory(qmidiarp_arp.lv2)
-add_subdirectory(qmidiarp_lfo.lv2)
-add_subdirectory(qmidiarp_seq.lv2)
+if (BUILD_LV2)
+  add_subdirectory(${PROJECT_NAME}_arp.lv2)
+  add_subdirectory(${PROJECT_NAME}_lfo.lv2)
+  add_subdirectory(${PROJECT_NAME}_seq.lv2)
+endif ()
+add_subdirectory(man)
+if (CONFIG_EXAMPLES)
+  add_subdirectory(examples)
+endif ()
 
 if (EXISTS ${CMAKE_SOURCE_DIR}/configure)
     set(ADD_AUTOCONF_FILES  --add-file=${CMAKE_SOURCE_DIR}/configure
@@ -333,7 +337,3 @@
                         git --git-dir=${CMAKE_SOURCE_DIR}/robtk/.git archive 
                         --format=tar 
                         --prefix=${PACKAGE_STRING}/robtk/ HEAD -o robtk.tar &&
-                        tar --concatenate --file=${PACKAGE_STRING}.tar robtk.tar && 
-                        rm -f robtk.tar)
-
-add_custom_target(dist-bz2 COMMAND ${DIST_TARCOMMAND} && bzip2 -f ${PACKAGE_STRING}.tar )

=== qmidiarp_lfo.lv2/CMakeLists.txt ===
install (FILES ${PROJECT_NAME}_lfo.ttl DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_lfo.lv2/)
install (FILES ${PROJECT_NAME}_lfo_ui.ttl DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_lfo.lv2/)
install (FILES manifest.ttl DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_lfo.lv2/)

## qmidiarp 0.7.2+ds

=== debian/changelog ===
qmidiarp (0.7.2+ds-2) unstable; urgency=medium

  * Fix builds without sse support
  * Add qt6-l10n-tools to B-Ds

 -- Dennis Braun <snd@debian.org>  Mon, 29 Dec 2025 14:27:00 +0100

qmidiarp (0.7.2+ds-1) unstable; urgency=medium

  * New upstream version 0.7.2+ds
  * Build with Qt6
  * Add missing build dependencies, thanks to Frank Kober (Closes: #1123929)
  * Remove redudant rules-requires-root-no field
  * Bump Standards-Version to 4.7.3
  * Update d/watch to version 5
  * Update d/coypright GPL-2+ license text
  * Update d/copyright years

 -- Dennis Braun <snd@debian.org>  Fri, 26 Dec 2025 16:06:11 +0100

=== debian/control ===
--- 
+++ 
@@ -9,16 +9,20 @@
 Build-Depends:
  debhelper-compat (= 13),
  libasound2-dev [linux-any],
+ libcairo2-dev,
  libjack-dev | libjack-jackd2-dev,
  liblo-dev,
+ libpango1.0-dev,
+ libpugl-dev,
  libx11-dev,
  lv2-dev,
- qtbase5-dev,
+ qt6-base-dev,
+ qt6-l10n-tools,
+ qt6-tools-dev-tools,
  qttools5-dev-tools,
  robtk,
  scour,
-Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Homepage: https://qmidiarp.sourceforge.io
 Vcs-Git: https://salsa.debian.org/multimedia-team/qmidiarp.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/qmidiarp

## qmidiarp 0.7.3%2Bds

=== qmidiarp_arp.lv2/CMakeLists.txt ===
install (FILES ${PROJECT_NAME}_arp.ttl DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2/)
install (FILES ${PROJECT_NAME}_arp_ui.ttl DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2/)
install (FILES manifest.ttl DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2/)

## qmidiarp 0.7.3+ds

=== examples/CMakeLists.txt ===
install (FILES demo.qmax DESTINATION ${CMAKE_INSTALL_DATADIR}/${PACKAGE_NAME}/examples)
install (FILES demo_seqlfo.qmax DESTINATION ${CMAKE_INSTALL_DATADIR}/${PACKAGE_NAME}/examples)
install (FILES demo_seqlfo2.qmax DESTINATION ${CMAKE_INSTALL_DATADIR}/${PACKAGE_NAME}/examples)
install (FILES demo_up_down.qmax DESTINATION ${CMAKE_INSTALL_DATADIR}/${PACKAGE_NAME}/examples)
install (FILES old_arp.qmax DESTINATION ${CMAKE_INSTALL_DATADIR}/${PACKAGE_NAME}/examples)

=== man/CMakeLists.txt ===
install (FILES ${PROJECT_NAME}.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
install (FILES fr/${PROJECT_NAME}.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/fr/man1)
install (FILES de/${PROJECT_NAME}.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/de/man1)

=== qmidiarp_seq.lv2/CMakeLists.txt ===
install (FILES ${PROJECT_NAME}_seq.ttl DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_seq.lv2/)
install (FILES ${PROJECT_NAME}_seq_ui.ttl DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_seq.lv2/)
install (FILES manifest.ttl DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_seq.lv2/)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -79,7 +79,7 @@
     
     if (CONFIG_TRANSLATIONS)
         add_subdirectory(translations)
-        set( DTRANSLATIONSDIR -DTRANSLATIONSDIR="${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/${PACKAGE}/translations/" )
+        set( DTRANSLATIONSDIR -DTRANSLATIONSDIR="${CMAKE_INSTALL_FULL_DATADIR}/${PACKAGE}/translations/" )
     endif()
     
     add_executable (${PROJECT_NAME}
@@ -103,7 +103,7 @@
                                                     Qt${QT_VERSION_MAJOR}::Widgets
                                                     )
     
-    if (UNIX AND NOT APPLE AND NOT CONFIG_DEBUG)
+    if (UNIX AND NOT APPLE AND STRIP_DEBUG_SYMBOLS)
       add_custom_command(TARGET ${PROJECT_NAME} POST_BUILD
         COMMAND strip ${PROJECT_NAME})
     endif ()
@@ -175,7 +175,7 @@
     set_target_properties (${PROJECT_NAME}_lfo PROPERTIES CXX_STANDARD 11 PREFIX "")
     set_target_properties (${PROJECT_NAME}_seq PROPERTIES CXX_STANDARD 11 PREFIX "")
 
-    if (UNIX AND NOT APPLE AND NOT CONFIG_DEBUG)
+    if (UNIX AND NOT APPLE AND STRIP_DEBUG_SYMBOLS)
       add_custom_command(TARGET ${PROJECT_NAME}_arp  POST_BUILD
         COMMAND strip ${PROJECT_NAME}_arp.so)
       add_custom_command(TARGET ${PROJECT_NAME}_lfo  POST_BUILD
@@ -185,9 +185,6 @@
     endif ()
 
     if (UNIX AND NOT APPLE)
-      if (CONFIG_PREFIX MATCHES $ENV{HOME})
-        set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
-      endif ()
       install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_arp.so
          DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2)
       install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_lfo.so
@@ -299,7 +296,7 @@
                                                     Qt${QT_VERSION_MAJOR}::Gui
                                                     Qt${QT_VERSION_MAJOR}::Widgets
                                                     )
-    if (UNIX AND NOT APPLE AND NOT CONFIG_DEBUG)
+    if (UNIX AND NOT APPLE AND STRIP_DEBUG_SYMBOLS)
       add_custom_command(TARGET ${PROJECT_NAME}_arp_ui  POST_BUILD
         COMMAND strip ${PROJECT_NAME}_arp_ui.so)
       add_custom_command(TARGET ${PROJECT_NAME}_lfo_ui  POST_BUILD
@@ -309,9 +306,6 @@
     endif ()
 
     if (UNIX AND NOT APPLE)
-      if (CONFIG_PREFIX MATCHES $ENV{HOME})
-        set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
-      endif ()
       install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_arp_ui.so
          DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2)
       install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_lfo_ui.so
@@ -386,9 +380,6 @@
     target_link_libraries (${PROJECT_NAME}_seq_ui_gl PUBLIC -lX11)
 
     if (UNIX AND NOT APPLE)
-      if (CONFIG_PREFIX MATCHES $ENV{HOME})
-        set (CONFIG_LV2DIR ${CONFIG_PREFIX}/.lv2)
-      endif ()
       install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_arp_ui_gl.so
          DESTINATION ${CONFIG_LV2DIR}/${PROJECT_NAME}_arp.lv2)
       install (FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}_lfo_ui_gl.so

=== src/translations/CMakeLists.txt ===
set (TS_SOURCES 
    ${CMAKE_SOURCE_DIR}/src/translations/${PACKAGE}_cs.ts
    ${CMAKE_SOURCE_DIR}/src/translations/${PACKAGE}_de.ts
    ${CMAKE_SOURCE_DIR}/src/translations/${PACKAGE}_es.ts
    ${CMAKE_SOURCE_DIR}/src/translations/${PACKAGE}_fr.ts
    )

set (QM_FILES 
    ${CMAKE_SOURCE_DIR}/src/translations/${PACKAGE}_cs.qm
    ${CMAKE_SOURCE_DIR}/src/translations/${PACKAGE}_de.qm
    ${CMAKE_SOURCE_DIR}/src/translations/${PACKAGE}_es.qm
    ${CMAKE_SOURCE_DIR}/src/translations/${PACKAGE}_fr.qm
    )

# add_custom_target(lupdate ALL COMMAND ${CONFIG_LUPDATE} ${CMAKE_SOURCE_DIR}/src -ts ${TS_SOURCES})

add_custom_target(lrelease ALL COMMAND Qt${QT_VERSION_MAJOR}::lrelease ${TS_SOURCES})
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/${PACKAGE}/translations/)

=== debian/changelog ===
qmidiarp (0.7.3+ds-1) unstable; urgency=medium

  * New upstream version 0.7.3+ds
  * Drop upstream patch
  * Remove redundant priority optional field

 -- Dennis Braun <snd@debian.org>  Mon, 12 Jan 2026 20:37:00 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: qmidiarp
 Section: sound
-Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-export QT_SELECT=qt5
+#export QT_SELECT=qt6
 
 
 %:

=== debian/watch ===
Version: 5
Repacksuffix: +ds
Dversion-Mangle: auto
Source: https://sf.net/@PACKAGE@/
Matching-Pattern: @PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@

## qmidiarp 0.7.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.10)
-project(qmidiarp VERSION 0.7.2
+project(qmidiarp VERSION 0.7.4
         DESCRIPTION "MIDI arpeggiator, sequencer and LFO for ALSA and JACK"
         LANGUAGES C CXX)

=== debian/changelog ===
qmidiarp (0.7.4+ds-1) unstable; urgency=medium

  * New upstream version 0.7.4+ds
  * Bump d/copyright years

 -- Dennis Braun <snd@debian.org>  Tue, 03 Mar 2026 19:09:23 +0100
